<?php

class Controller_Office_Teachers extends Controller_Environment_Office
{
    public function action_index() {
        # todo: sub-menus
        $this->action_search();
    }

    public function action_search() {
        $this->twig->set([
            'Faculties'   => Model_Faculties::load(),
            'Departments' => $this->user->Faculty->getDepartments(),
        ])->set_filename(static::OFFICE . 'teachers/search');
    }

    public function action_add() {
        $this->twig->set([
            'Faculties'    => Model_Faculties::load(),
            'JobPositions' => Model_Teachers::getJobPositions(),
            'Departments'  => $this->user->Faculty->getDepartments(),
        ])->set_filename(static::OFFICE . 'teachers/add');
    }

    public function action_upload() {
        $errors = [];

        if (!empty($_FILES['teachers']) && $this->request->method() == 'POST') {
            $file = $_FILES['teachers']['tmp_name'];
            $errors = FileParser::uploadTeachers($file, $_POST['facultyID']);
        }

        $this->twig->set([
            'Errors'    => $errors,
            'Faculties' => Model_Faculties::load(),
        ])->set_filename(static::OFFICE . 'teachers/upload');
    }

    public function action_profile() {
        $id = $this->request->param('id');
        
        if (!$id) $this->redirect(Route::get('office:common')->uri());
        
        $this->twig->set([
            'Profile' => Model_Account::with($id),
            'Account' => Model_Account::with($id),
        ])->set_filename(static::OFFICE . 'teachers/profile');
    }
}
